####################################################
package BU::PSA::Backup::ActionLog;
####################################################
require 5.000;
require Exporter;

use BU::PSA::Const;
use BU::PSA::CommonFunc;
use BU::PSA::Logger;
use BU::PSA::DB;
use BU::PSA::MIME::Add2Stream;
use BU::XML::CommonFunc;

use MIME::Base64 qw(encode_base64 decode_base64);

use BU::PSA::ActionLog;

@ISA = qw(Exporter);

@EXPORT = qw(dumpActionLogPrefsRef dumpActionLogRef);


sub dumpActionLogPrefsRef
{
	my ($doc) = @_;

	my $base_node = $doc->createElement('action_log_prefs');

	my $query = dbDoQuery('SELECT id, name, descr, enabled FROM actions');
	while (my ($id, $name, $desc, $enabled) = $query->fetchrow_array()) {
		my $sn = $doc->createElement('action');
		$sn->setAttribute('id', $id);
		$sn->setAttribute('name', $name);
		$sn->setAttribute('enabled', ($enabled eq 'true') ? 'true' : 'false');
		$sn->setAttribute('desc', a2u($desc));
		$base_node->appendChild($sn);
	}

	return $base_node;
}


sub dumpActionLogRef($$$)
{
	my ($doc, $object_id, $object_type) = @_;

	my $base_node = undef;

	my $actions_arr = getActionsByObjectType($object_id, $object_type);
	my $actions_list = join '","', @$actions_arr;
	$actions_list = '"'. $actions_list . '"';

	my $query = dbDoQuery('SELECT a.name, la.id, la.user, la.ip_address, la.date FROM actions a, log_actions la WHERE a.id=la.action_id AND (a.name in ('.$actions_list.')) AND la.object_id="' . $object_id . '"');
	while (my $href = $query->fetchrow_hashref()) {
		$base_node = $doc->createElement('action_log') unless ($base_node); ### group element

		my $sn = $doc->createElement('action'); ### subgroup element

		my $logged_action_id = $$href{'id'};
		delete $$href{'id'};

		while (my ($attr, $value) = each(%$href)) {
			$sn->setAttribute($attr, a2u($value));
		}

		my $query2 = dbDoQuery('SELECT component, old_value, new_value FROM log_components  WHERE action_id="' . $logged_action_id . '"');
		while (my ($attr, $old_value, $new_value) = $query2->fetchrow_array()) {
			my $sn2 = $doc->createElement('component'); ### simple element
			$sn2->setAttribute('name', a2u($attr));
			$sn2->setAttribute('old_value', a2u($old_value));
			$sn2->setAttribute('new_value', a2u($new_value));
			$sn->appendChild($sn2);
		}
		$base_node->appendChild($sn);
	}

	return $base_node;
}


return 1;

