####################################################
package BU::PSA::Backup::Admin;
####################################################
require 5.000;
require Exporter;

use BU::PSA::Const;
use BU::PSA::CommonFunc;
use BU::PSA::Logger;
use BU::PSA::DB;
use BU::PSA::MIME::Add2Stream;
use BU::XML::CommonFunc;
use MIME::Base64 qw(encode_base64 decode_base64);

use BU::PSA::Backup::CommonFunc;
use BU::PSA::Backup::ActionLog;
use BU::PSA::Backup::Common;
use BU::PSA::Map;


@ISA = qw(Exporter);

@EXPORT = qw(dumpAdminUserRef);


sub dumpAdminUserRef
{
	my ($doc) = @_;

	my $base_node = createUserRef($doc, 'admin', '0', 'admin', '', {'PW_TYPE' => 'empty'});

	my $sn = createCardRef($doc, getMiscParam(undef), \%adm_card_fields);
	addSubNode($base_node, $sn);

	### dump actions
	addSubNode($base_node, dumpActionLogRef($doc, 0, 'admin'));

	### dump custom reports
	addSubNode($base_node, dumpCustomReportsRef($doc, 0, $const{'IS_ADMIN'}));

	### dump custom buttons
	addSubNode($base_node, dumpCustomButtonsRef($doc, 0, $const{'IS_ADMIN'}));

	{### dump admin's params
		$psn = $doc->createElement('params');
		$base_node->appendChild($psn);

		my @adm_params_attr = ('lines_per_page','dom_page','cl_sort', 'dom_sort');
		foreach my $i (@adm_params_attr) {
			$psn->setAttribute($i, $misc{$i});
		}

		my $query= dbDoQuery('SELECT l.name, l.fake, l.url, l.showMode FROM Logos l, misc m WHERE m.param="logo_id" and m.val=l.id');
		if (my ($file_name, $fake_file_name, $url, $showMode) = $query->fetchrow_array) {
			my $sn = $doc->createElement('logo');
			$sn->setAttribute('file', a2u($file_name));
			$sn->setAttribute('url', $url) if $url;
			$sn->setAttribute('show_mode', a2u($showMode)) if $showMode;
			addLogo2Stream($sn, $fake_file_name) if $fake_file_name;

			$psn->appendChild($sn);
		}
	}

	return $base_node;
}


return 1;

