###################################################################
package BU::PSA::Backup::DomainLevelUser;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::CommonFunc;
use BU::XML::CommonFunc;
use BU::PSA::Map;

use BU::PSA::Backup::CommonFunc;
use BU::PSA::Backup::ActionLog;

@ISA = qw(Exporter);

@EXPORT = qw(dumpDomainLevelUserRef);

sub dumpDomainLevelUserRef
{
	my ($doc, $dom_id, $domainName) = @_;

	my $base_node = undef;

	return undef unless $backup_filter{'DOMAIN_OWNER'};

	my $query = dbDoQuery('SELECT dlu.*, a.type, a.password FROM dom_level_usrs dlu LEFT JOIN accounts a on a.id=dlu.account_id WHERE dom_id="' . $dom_id . '"');
	my $href = $query->fetchrow_hashref();

	return undef unless $href;

	my $card_id = $$href{card_id};
	delete $$href{dom_id};
	delete $$href{card_id};

	$base_node = createUserRef($doc, 'domain_level', '5', $domainName, $$href{password},
								{'PW_TYPE' => $$href{type}});
	$base_node->setAttribute('status', $$href{state});

	### dump action log for domain level users
	addSubNode($base_node, dumpActionLogRef($doc, $dom_id, 'dl_user'));

	{### dump card's info for domain level user
		my $query = dbDoQuery('SELECT * FROM Cards crd WHERE crd.id="' . $card_id . '"');
		if (my $href2 = $query->fetchrow_hashref()) {
			if (my $sn = createCardRef($doc, $href2, \%new_card_fields)) {
				$base_node->appendChild($sn);
			}
		}
	}

	{### dump permissions of domain level user
		my $node = $doc->createElement('permissions');
		$base_node->appendChild($node);
		my $query = dbDoQuery('SELECT p.permission, p.value FROM Permissions p, dom_level_usrs du WHERE du.perm_id=p.id AND du.dom_id=\'' . $dom_id . '\'');
		while (my ($name, $value) = $query->fetchrow_array()) {
			$node->setAttribute($name, ($value eq 'true') ? 'true' : 'false');
		}
	}

	return $base_node;
}


return 1;

