###################################################################
package BU::PSA::Backup::MailList;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::CommonFunc;
use BU::PSA::MIME::Add2Stream;

use BU::PSA::Backup::CommonFunc;

@ISA = qw(Exporter);

@EXPORT = qw(dumpMailList);


sub dumpMailList
{
	my ($doc, $name, $status) = @_;

	my $base_node = $doc->createElement('mail_list');
	$base_node->setAttribute('name', $name);
	$base_node->setAttribute('status', $status);

	my $sn = undef;
	my $path = undef;

	$path = $conf{MAILMAN_ROOT_D} . "/lists/$name";
	if (-d $path) {
		$sn = $doc->createElement('config_dir');
		addDir2Stream($sn, 0, '.', $path);
		$base_node->appendChild($sn);
	}

	$path = $conf{MAILMAN_ROOT_D} . "/archives/private/$name";
	if (-d $path) {
		my $sn = $doc->createElement('archive_private_dir');
		$base_node->appendChild($sn);
		addDir2Stream($sn, 0, '.', $path);
	}

	$path = $conf{MAILMAN_ROOT_D} . "/archives/private/$name.mbox";
	if (-d $path) {
		$sn = $doc->createElement('archive_private_mbox_dir');
		$base_node->appendChild($sn);
		addDir2Stream($sn, 0, '.', $path);
	}

	return $base_node;
}


return 1;

