###################################################################
package BU::PSA::Backup::PDir;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::CommonFunc;

use BU::PSA::Backup::CommonFunc;

@ISA = qw(Exporter);

@EXPORT = qw(dumpPDirs dumpPDirRef);

sub dumpPDirs
{
	my ($doc, $base_node, $dom_id) = @_;

	my $query = dbDoQuery('SELECT * FROM protected_dirs WHERE dom_id="' . $dom_id . '"');
	while ( my $href = $query->fetchrow_hashref ) {
		if (my $sn = dumpPDirRef($doc, $href)) {
			$base_node->appendChild($sn);
		}
	}
}


sub dumpPDirRef
{
	my ($doc, $href) = @_;

	my $base_node = $doc->createElement('protected_dir');

	my $pd_id = $$href{id};
	delete $$href{id};

	$base_node->setAttribute('path', $$href{path});

	my $sn = $doc->createElement('realm');
	$sn->appendChild($doc->createTextNode(a2u($$href{realm})));
	$base_node->appendChild($sn);

	if(my $sn = createServicesRef($doc, $href, 'ssl', 'non_ssl')) {
		$base_node->appendChild($sn);
	}

	my $query = dbDoQuery('SELECT pd.login, a.type, a.password FROM pd_users pd, accounts a WHERE pd.account_id=a.id AND pd.pd_id="' . $pd_id . '"');
	while (my ($login, $pw_type, $password) = $query->fetchrow_array ) {
		my $node=createUserRef($doc, 'pd_users', '4', $login, $password, {'PW_TYPE' => $pw_type} );
		$base_node->appendChild($node);
	}

	return $base_node;
}

return 1;

