###################################################################
package BU::PSA::Backup::SiteApp;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::XML::CommonFunc;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::CommonFunc;

use BU::PSA::Backup::CommonFunc;

@ISA = qw(Exporter);

@EXPORT = qw(dumpSiteAppsRef);


sub dumpSiteAppsRef
{
	my ($doc, $dom_type, $dom_id) = @_;

	my $base_node = undef;

	my $query = dbDoQuery('SELECT * FROM SiteApps WHERE dom_type="' . $dom_type . '" AND dom_id="' . $dom_id . '"');
	while (my $href = $query->fetchrow_hashref()) {
		$base_node = $doc->createElement('site_apps') unless $base_node;

		my $app_id = $$href{'id'};
		my $params_id = $$href{'params_id'};

		delete $$href{'dom_id'};
		delete $$href{'params_id'};

		my $node = createNodeFromHash($doc, 'site_app', $href);
		$base_node->appendChild($node);

		{### dump params for siteapp
			my $sn = $doc->createElement('params');
			$node->appendChild($sn);
			my $query = dbDoQuery('SELECT parameter, value FROM Parameters WHERE id="' . $params_id . '"');
			while (my ($name, $value) = $query->fetchrow_array()) {
				my $sn2 = $doc->createElement('parameter');
				$sn2->setAttribute('name', a2u($name));
				$sn2->setAttribute('value', a2u($value));
				$sn->appendChild($sn2);
			}
		}
		{### dump resources
			my $sn = $doc->createElement('resources');
			$node->appendChild($sn);
			my $query = dbDoQuery('SELECT type, res_id FROM SiteAppResources WHERE app_id="' . $app_id . '"');
			while (my ($type, $res_id) = $query->fetchrow_array()) {
				my $sn2 = $doc->createElement('resource');
				$sn2->setAttribute('type', a2u($type));
				$sn2->setAttribute('res_id', a2u($res_id));
				$sn->appendChild($sn2);
			}
		}
	}

	return $base_node;
}


return 1;

