###################################################################
package BU::PSA::Backup::SubDomain;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::MIME::Add2Stream;
use BU::PSA::CommonFunc;
use BU::XML::CommonFunc;

use BU::PSA::Backup::CommonFunc;
use BU::PSA::Backup::SiteApp;
use BU::PSA::Backup::ActionLog;

@ISA = qw(Exporter);

@EXPORT = qw(dumpSubDomainsRef dumpSubDomainRef);


sub dumpSubDomainsRef
{
	my ($doc, $dom_id, $domainName) = @_;

	my $base_node = $doc->createElement('subdomains');

	my $query = dbDoQuery('SELECT * FROM subdomains WHERE dom_id="' . $dom_id . '"');
	while (my $href = $query->fetchrow_hashref()) {
		addSubNode($base_node, dumpSubDomainRef($doc, $dom_id, $domainName, $href));
	}

	return $base_node;
}


sub dumpSubDomainRef
{
	my ($doc, $dom_id, $domainName, $href) = @_;

	my $base_node = createNodeFromHash($doc, 'subdomain', $href);

	my $sys_user_id = $$href{sys_user_id};
	delete($$href{sys_user_id});

	### dump action log for subdomain
	addSubNode($base_node, dumpActionLogRef($doc, $dom_id, 'subdomain'));

	### retrive system user info for subdomain if the system user differ from hosting system user
	my $query = dbDoQuery('SELECT h.sys_user_id!=su.id as private_user, su.*, a.* FROM hosting h, sys_users su LEFT JOIN accounts a ON (a.id=su.account_id) WHERE h.dom_id=' . $dom_id . ' AND su.id=' . $sys_user_id);
	if (my $href2 = $query->fetchrow_hashref()) {
		if ($$href2{'private_user'}) {
			my $su_node = createUserRef($doc, 'subdomain', '4', $$href2{'login'}, $$href2{'password'},
							{'real' => 'true', 'PW_TYPE' => $$href2{'type'}, 'shell' => a2u($$href2{'shell'}),
							 'quota' => $$href2{'quota'}, 'home' => a2u($$href2{'home'})});
			$base_node->appendChild($su_node);
		}

		my $uid = getpwnam $$href2{'login'};
		addSubDomain2Stream($base_node, $uid, $domainName, $$href{'name'});

		my $sys_data_node = $doc->createElement('system_data');
		$base_node->appendChild($sys_data_node);
		addSubDomain2Stream($sys_data_node, 0, $domainName, $$href{'name'});

		if (my $site_apps_node = dumpSiteAppsRef($doc, 'subdomain', $$href{'id'})) {
			$base_node->appendChild($site_apps_node);
		}
	}

	return $base_node;
}


return 1;

