###################################################################
package BU::PSA::Backup::WebUser;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;
use BU::PSA::DB;
use MIME::Base64 qw(encode_base64 decode_base64);
use BU::PSA::CommonFunc;
use BU::XML::CommonFunc;
use BU::PSA::MIME::Add2Stream;

use BU::PSA::Backup::CommonFunc;
use BU::PSA::Backup::Common;
use BU::PSA::Backup::ActionLog;

@ISA = qw(Exporter);

@EXPORT = qw(dumpWebUsers dumpWebUserRef);


sub dumpWebUsers
{
	my ($doc, $base_node, $dom_id, $domainName) = @_;

	my $query = dbDoQuery('SELECT wu.*, su.*, a.password, a.type FROM web_users wu, sys_users su LEFT JOIN accounts a on (su.account_id=a.id) WHERE wu.sys_user_id=su.id AND wu.dom_id="' . $dom_id . '"');
	while ( my $href = $query->fetchrow_hashref ) {
		delete $$href{dom_id};

		if (my $sn = dumpWebUserRef($doc, $href, $domainName)) {
			$base_node->appendChild($sn);
		}
	}
}


sub dumpWebUserRef
{
	my ($doc, $href, $domainName) = @_;

	my $base_node = undef;

	my $shell = undef;
	if (exists($$href{shell}) && $$href{shell}) {
		$shell = $$href{shell};
	} else {
		my @pw_info = getpwnam($$href{login});
		$shell = $pw_info[8];
	}

	my $base_node = createUserRef($doc, 'web_users', '3', $$href{'login'}, $$href{'password'},
						{'real' => 'true',
						 'PW_TYPE' => $$href{'password'} ? $$href{'type'} : 'empty',
						 'shell' => a2u($shell),
						 'quota' => $$href{quota}, 'home' => a2u($$href{home})});

	addDir2Stream($base_node, 0, $$href{'login'}, $conf{HTTPD_VHOSTS_D} . "/$domainName/web_users");

	my @wu_services=('ssi', 'php', 'cgi', 'perl', 'asp', 'python');
	$base_node->appendChild(createServicesRef($doc, $href, @wu_services));

	### dump crontab for webuser
	addSubNode($base_node, dumpCrontabRef($doc, $$href{login}));

	### dump action log for web user
	addSubNode($base_node, dumpActionLogRef($doc, $$href{'id'}, 'webuser'));

	return $base_node;
}


return 1;

