###################################################################
package BU::PSA::Logger;
###################################################################
require 5.000;
require Exporter;

use BU::Logger;

@ISA = qw(BU::Logger);

@EXPORT = qw(
LoggerInit
print_log printf_log print_stdout printf_stdout print_stderr printf_stderr
warn_log die_log
getProcessingLogFileName reopenProcessingLogFile closeProcessingLogFile
addNotDumpedDomain printNotDumpedDomains
addNotRestoredDomain printNotRestoredDomains

$SHOW_PROCESSING
);

##################################################################
#  Names of domains, which were turned off for backup operations
#  during server-wide backup. They will be printed on admin's
#  console.
#  It's better to make it hash "Name" => "Reason"
##################################################################
my @notDumpedDomains = ();

sub addNotDumpedDomain    { push(@notDumpedDomains, (@_));}

sub printNotDumpedDomains { 
   if ($#notDumpedDomains > 0) {
      print_stderr("Domains not dumped due to their own backup/restore procedure running:\n\t".
         join("\n\t", sort(@notDumpedDomains)));
   }
}

##################################################################
#  Names of domains, which were turned off for backup operations
#  during server-wide restore. They will be printed on admin's
#  console.
#  It's better to make it hash "Name" => "Reason"
##################################################################
my @notRestoredDomains = ();

sub addNotRestoredDomain    { push(@notRestoredDomains, (@_));}

sub printNotRestoredDomains { 
   if ($#notRestoredDomains > 0) {
      print_stderr("Domains not restored due to their own backup/restore procedure running:\n\t".
         join("\n\t", sort(@notRestoredDomains)));
   }
}

return 1;

