###################################################################
package BU::PSA::Map;
###################################################################

require 5.004;
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(%card_fields %card_fields_rev %adm_card_fields %adm_card_fields_rev %new_card_fields %new_card_fields_rev);


# map database field name to xml node name for 'clients' table.
%card_fields = (map {$_ => $_} 
	'pname', 'cname', 'phone', 'fax', 'email', 'address', 
	'city', 'state', 'pcode', 'country', 'locale'
);


# maping user card fields to PSA admin card fields
%adm_card_fields = (
	'admin_email'	=> 'email',
	'admin_cname'	=> 'cname',
	'admin_pname'	=> 'pname',
	'admin_phone'	=> 'phone',
	'admin_fax'		=> 'fax',
	'admin_address'	=> 'address',
	'admin_city'	=> 'city',
	'admin_state'	=> 'state',
	'admin_pcode'	=> 'pcode',
	'admin_country'	=> 'country',
	'admin_locale'	=> 'locale'
);

# new format of card's fields
%new_card_fields = ( 
	'personalName' => 'pname',
	'companyName' => 'cname',
	'phone' => 'phone',
	'fax' => 'fax',
	'email' => 'email',
	'address' => 'address',
	'city' => 'city',
	'state' => 'state',
	'zip' => 'zip',
	'country' => 'country'
);


# reverse hashes 
%card_fields_rev = ();
%adm_card_fields_rev = ();
%new_card_fields_rev = ();


sub hashReverse {
	my ($source, $reverse)=@_;

	while (my ($key, $val) = each(%$source)) { $reverse->{$val}=$key; }
	return $rev;
}

hashReverse(\%adm_card_fields, \%adm_card_fields_rev);
hashReverse(\%card_fields, \%card_fields_rev);
hashReverse(\%new_card_fields, \%new_card_fields_rev);

return 1;

__END__

=head1 NAME

PSA::Map

=head1 DESCRIPTION

     .   
  ,    
    .

=head1 SYNOPSIS

#  
use PSA::Map.pm

#       'email',   
#  'admin_email',      :
$admin_email_field_name = $adm_card_fields{'email'};
print $admin_email_field_name;

  : admin_email


#   -       'admin_email'
#  ,   :
$email_common_field_name = $adm_card_fields_rev{'admin_email'};
print $email_common_field_name;

  : email

=cut

