###################################################################
package BU::PSA::Objects::Account;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::DB;
use BU::PSA::Objects::Object;

@ISA = qw(BU::PSA::Objects::Object);


sub init
{
	my $self = shift @_;
	my ($id) = @_;

	$self->{dbFieldsNames} = {'type' => 1, 'password' => 0};

	$self->{dbTable} = 'accounts';
	$self->{Changeable} = 1;

	$self->SUPER::init(@_);
	$self->setDBId($id);

	$$self{action_log_map} = {
		'password' => COMP_SYSUSER_PASSWD
	};

	return $self;
}


sub dbGetIdCondition()
{
	my ($self) = @_;
	return 'id=' . dbQuote($self->{dbId});
}


sub dbExistsCondition()
{
	my ($self) = @_;
	return 'id=' . dbQuote($self->{dbId});
}


sub Store
{
	my ($self) = @_;

	unless ($self->getField('password')) {
		$self->setDBId(0);
		return 1;
	}

	return $self->SUPER::Store(@_);
}

return 1;

