###################################################################
package BU::PSA::Objects::Limits;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::DB;

use BU::Objects::ErrHandler;

@ISA = qw(BU::Objects::ErrHandler);

sub init
{
	my $self = shift @_;
	my ($limitsId) = @_;

	$self->SUPER::init();

	$$self{limitsId} = $limitsId;
	$$self{changed} = 1;

	my %limitsList = ();
	$$self{limitsList} = \%limitsList;


	return $self;
}


sub getValue($)
{
	my ($self, $limit) = @_;
	$self->resetError();

	my $limitsList = $$self{limitsList};
	return (exists ($$limitsList{$limit}) ? $$limitsList{$limit} : -1);
}


sub setValue($ $)
{
	my ($self, $limit, $value) = @_;
	$self->resetError();

	my $limitsList = $$self{limitsList};
	$$self{changed} = ($$limitsList{$limit} ne $value);
	$$limitsList{$limit} = $value;

	return 1;
}


sub fetchList()
{
	my ($self) = @_;
	$self->resetError();

	my $query = dbDoQuery('SELECT limit_name, value FROM Limits WHERE id=' . dbQuote($$self{limitsId}));
	unless ($query) {
		$self->setError('Unable to fetch limits list.');
		return undef;
	}

	my $limitsList = $$self{limitsList};
	while (my ($limit, $value) = $query->fetchrow_array()) {
		$$limitsList{$limit} = $value;
	}

	$$self{changed} = '';

	return 1;
}


sub updateList()
{
	my ($self) = @_;
	$self->resetError();

	my $limitsList = $$self{limitsList};
	while (my ($limit, $value) = %$limitsList) {
		my $query = dbDoQuery('REPLACE INTO Limits(id, limit_name, value) VALUES(' . dbQuote($$self{limitsId}) . ", '$limit', '$value')");
		unless ($query) {
			$self->setError('Unable to fetch limits list.');
			return undef;
		}
	}

	$$self{changed} = '';

	return 1;
}

return 1;

