###################################################################
package BU::PSA::Objects::MailAutoresponder; #psa3.0
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::DB;
use BU::PSA::CommonFunc;

use BU::PSA::Objects::Object;

@ISA = qw(BU::PSA::Objects::Object);


sub init($ $)
{
	my $self = shift @_;
	my ($mailId, $respName) = @_;

	my $fields = $self->{dbFields};

	defined($mailId) and $fields->{mn_id} = $mailId or croak "Argument 'mailId' is undefined.";
	defined($respName) and $fields->{resp_name} = $respName; # RESPONDER NAME CAN BE EMPTY!!!
#	defined($mailName) and $fields->{mail_name} = $mailName or croak "Argument 'mailName' is undefined.";
#	defined($mailPassword) and $fields->{password} = $mailPassword or croak "Argument 'mailPassword' is undefined.";

	$self->{dbFieldsNames} = {
								'mn_id' => 1, 'resp_name' => '', 'reply_to' => '',
								'keystr' => '', 'key_where' => '', 'subject' => '', 'text' => '',
								'resp_on' => '', 'ans_freq' => '', 'mem_limit' =>''
							};

	$self->{dbTable} = 'mail_resp';
	$self->{Changeable} = '';

	$self->SUPER::init(@_);

	return $self;
}


sub dbGetIdCondition()
{
	my ($self) = @_;

	my $fields = $self->{dbFields};

	return 'resp_name=' . dbQuote($fields->{resp_name})
		.  ' AND mn_id=' . $fields->{mn_id};
}


sub dbExistsCondition()
{
	my ($self) = @_;

	return $self->dbGetIdCondition();
}


#sub doCheckExists
#{
#	my ($self) = @_;
#
#	my $fields = $self->{dbFields};
#
#	if (util_exec('mailmng', ('exist', $fields->{mail_name}))) {
#		return 1;
#	}
#
#	return '';
#}


#sub doCreate
#{
#	my ($self) = @_;
#
#	my $fields = $self->{dbFields};
#
#	$self->resetError();
#
#	return 1;
#}


sub setRespFreq($ $)
{
	my ($self, $email, $timeResp, $num) = @_;

	unless (dbDoQuery('REPLACE INTO resp_freq(rn_id, email, time_resp, num) VALUES('
						. $self->getDBId() . ', '
						. dbQuote($email) . ', '
						. dbQuote($timeResp) . ', '
						. dbQuote($num) . ')'
					))
	{
		$self->setError('Unable to set autoresponder frequency: ' . $DBI::error);
		return '';
	}

	return 1;
}


sub addAttachment($)
{
	my ($self, $fileName) = @_;

	my $query = dbDoQuery('REPLACE INTO resp_attach(rn_id, filename)'
						. ' VALUES('.$self->getDBId() . ', ' . dbQuote($fileName) . ')');

	unless ($query) {
		$self->setError('Unable to add attachment: ' . $DBI::error);
		return '';
	}

	return 1;
}


sub setForward($)
{
	my ($self, $address) = @_;

	unless (dbDoQuery('REPLACE INTO resp_forward(rn_id, address) '
					. 'VALUES(' . $self->getDBId() . ', '. dbQuote($address) . ')'))
	{
		$self->setError('Unable to set forward: ' . $DBI::error);
		return '';
	}

	return 1;
}


return 1;

