###################################################################
package BU::PSA::Objects::MailList;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::DB;
use BU::PSA::Objects::Object;
use Digest::MD5 qw(md5_hex);
use BU::PSA::Logger;

@ISA = qw(BU::PSA::Objects::Object);

sub init
{
	my $self = shift @_;
	my ($domainId, $name, $domainName) = @_;

	my $fields = $$self{dbFields};

	$$fields{name} = $name;
	$$fields{dom_id} = $domainId;
	$$self{domainName} = $domainName;

	$$self{dbFieldsNames} = {'name' => 1, 'status' => 0, 'dom_id' => 1};

	$$self{dbTable} = 'MailLists';
	$$self{Changeable} = 1;

	$self->SUPER::init(@_);

	return $self;
}


sub dbGetIdCondition()
{
	my ($self) = @_;

	return 'name=' . dbQuote($self->getField('name'));
}


sub dbExistsCondition()
{
	my ($self) = @_;
	return $self->dbGetIdCondition();
}


sub doCheckExists
{
	my ($self) = @_;
	$self->resetError();

	my $path = $conf{MAILMAN_ROOT_D} . '/lists/' . $self->getField('name');

	return (-d $path);
}


sub doCreate()
{
	my ($self) = @_;
	$self->resetError();

	my %env = (LISTPWD => substr(md5_hex(rand()), 0, 10));
	unless ($self->utilExecEnv('listmng', \%env, 'create', $self->getField('name'), $$self{'domainName'}, 'fake@localhost.net', 'quiet')) {
		$self->setError('Unable to create maillist: ' . $self->getErrorMsg());
		return '';
	}

#	if ($self->Exists()) {
		unless ($self->utilExecAC('listmng', 'turn', $self->getField('name'), $$self{'domainName'}, ($self->getField('status') == 0) ? 'on' : 'off')) {
			$self->setError('Unable to create maillist: ' . $self->getErrorMsg());
			return '';
		}
#	}

	return 1;
}

return 1;

