package BU::PSA::Restore::System;

require 5.004;
require Exporter;

use BU::PSA::Const;
use BU::PSA::Logger;
use BU::FileFunc;
use BU::PSA::CommonFunc;
use BU::PSA::DB;
use BU::XML::CommonFunc;

@ISA = qw(Exporter);
@EXPORT = qw(restoreSystem restoreIMPHordeDB);

sub restoreSystem($)
{
	my ($systemNode) = @_;

	if ($flags{RESTORE_MODE} eq 'CHECK') {
		foreach my $dbNode ($systemNode->xql('./data_bases')) {
			hashXMLNodeByCID($dbNode);
		}

		return 1;
	} elsif ($flags{RESTORE_MODE} ne 'RESTORE') {
		return '';
	}

	printf_stdout("\n%s not PSA objects: \n", $ProcessName);

	foreach my $dbNode ($systemNode->xql('./data_bases')) {
		next if ($dbNode->getAttribute('collision') eq 'true');

		my $dbName = u2a($dbNode->getAttribute('name'));

		printf_stdout "%s database '%s'\n", $ProcessName, $dbName;

		if ($dbName eq 'horde') {
			restoreIMPHordeDB($dbNode);
			next;
		}

		unless (existDir($conf{MYSQL_VAR_D} . "/$dbName")) {
#		unless ( -d $conf{MYSQL_VAR_D} . "/$dbName") {
			dbDoQuery("CREATE DATABASE $dbName");
		}

		foreach my $accessRightsNode ($dbNode->xql('./access_rights')) {
			my $nodesList = $accessRightsNode->getAttributes();
			my $buff = XMLAttrs2SQL('REPLACE INTO mysql.db(Db, %s) VALUES('.dbCorrectDBName($dbName).', %s)',
									$nodesList, 1);

			dbDoQuery($buff);
		}
	}

	foreach my $dbUserNode ($systemNode->xql('./user[@type="db_users"]')) {
		next if ($dbUserNode->getAttribute('collision') eq 'true');

		my ($userLoginNode) = $dbUserNode->xql('./login');

		my $dbUserName = u2a($userLoginNode->getAttribute('name'));

		printf_stdout "%s database user '%s'\n", $ProcessName, $dbUserName;

		next unless $dbUserName;

		foreach my $accessRightsNode ($dbUserNode->xql('./access_rights')) {
			my $nodesList = $accessRightsNode->getAttributes();
			my $buff = XMLAttrs2SQL('REPLACE INTO mysql.user(User, %s) VALUES('.dbQuote($dbUserName).', %s)',
									$nodesList, 1);

			dbDoQuery($buff);
		}
	}

	return 1;
}


sub restoreIMPHordeDB
{
	my ($node) = @_;
return 1;

	print_stdout("\nRestore IMP Horde database content\n");

	if ($flags{RESTORE_MODE} eq 'CHECK') {
		return 1;
	} elsif ($flags{RESTORE_MODE} ne 'RESTORE') {
		return '';
	}

#	unless (-d $conf{MYSQL_VAR_D} . '/horde') {
#		print_stderr("IMP Horde database content restoration is skipped, because 'horde' database is not exists.");
#		return 1;
#	}

#	foreach my $table_node ($node->xql('./table')) {
#		my $tableName = 'horde.' . $table_node->getAttribute('name');
#		foreach my $rec_node ($table_node->xql('./record')) {
#			my $nodesList = $rec_node->getChildNodes();
#			my $buff = XMLNodesList2SQL('REPLACE INTO ' . $tableName . '(%s) VALUES(%s)', $nodesList, {decode_base64 => 1});
#			dbDoQuery($buff);
#		}
#	}

	return 1;
}


return 1;

